// Copyright (C) 2016 EDF
// All Rights Reserved
// This code is published under the GNU Lesser General Public License (GNU LGPL)
#ifndef  BOOSTOSTDSHARED_PTR
#define  BOOSTOSTDSHARED_PTR
#include <memory>
#include <boost/shared_ptr.hpp>
#include <boost/bind.hpp>


/** \file BoostToStdSharedPtr.h
 * transform a boost to std shared_ptr
 * \author Xavier Warin
 */

/// \brief utility
template<typename T>
void do_release(typename boost::shared_ptr<T> const &, T *)
{
}

/// \brief Convert boost shared_ptr to std shared_ptr
template<typename T>
typename std::shared_ptr<T> make_shared_ptr(typename boost::shared_ptr<T> const &p)
{
    return
        std::shared_ptr<T>(
            p.get(),
            boost::bind(&do_release<T>, p, _1));

}

#endif
